/* Inisialisasi port LCD dan 1 Wire bus */
#asm
    .equ __w1_port=0x1b
    .equ __w1_bit=3
    .equ __lcd_port=0x1b
#endasm                   

#include <lcd.h>                // LCD driver routines
#include <delay.h>              // Delay routines
#include <stdio.h>              // Standard I/O routines
#include <1wire.h>              // 1 Wire driver routines

char lcd_buffer[18];
unsigned char buffer[9];

main()
{ 
unsigned char i;
int temp;

lcd_init(16);

/* Tulis Konfigurasi DS1822 ke Scratchpad */
w1_init();                      // Inisialisasi 1 Wire
w1_write(0xcc);                 // Skip ROM
w1_write(0x4e);                 // Write Scratchpad
w1_write(0x7d);                 // TH= +125 (Alarm tidak aktif)
w1_write(0xc9);                 // TL= -55
w1_write(0x7f);                 // Konfigurasi 12-bit

/* Kopi Konfigurasi DS1822 dari Scratchpad ke EEPROM */
w1_init();                      // Inisialisasi 1 Wire
w1_write(0xcc);                 // Skip ROM
w1_write(0x48);                 // Copy Scratchpad to EEPROM

/* Konversi suhu dan tampilkan di LCD */
while (1)
  {
  /* DS1822 Mulai konversi suhu */
  w1_init();                     // Inisialisasi 1 Wire
  w1_write(0xcc);                // Skip ROM
  w1_write(0x44);                // Convert T
  delay_ms(800);                 // Tunggu konversi selesai >750 ms
  
  /* Baca data suhu di Scratchpad */
  w1_init();                     // Inisialisasi 1 Wire
  w1_write(0xcc);                // Skip ROM
  w1_write(0xbe);                // Baca Scratchpad
  for (i=0;i<9;i++) buffer[i]=w1_read();
  
  /* Gabungkan 2 byte data suhu */
  temp=(buffer[1]*256)+buffer[0];
  
  /* Tampilkan data suhu di LCD */
  i='+';
  if (temp<0) {temp=-temp;i='-';};
  sprintf(lcd_buffer,"T=%c%i.%04u\xdfC",i,temp/16,temp%16*625);
  lcd_clear();
  lcd_puts(lcd_buffer);
  };
}